/* aib.h */

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/lists.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>

#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/exec_protos.h>
#include <clib/asl_protos.h>
#include <stdlib.h>

#include "gad_ids.h"

/* some constant definitions */
#define MIN_VERSION     36L      /* minimum version number for our libs */

/* some struct. defs */
struct Their_Window {
	struct Window *sketchpad;
	LONG flags;
	LONG left,top,width,height;
	char title[256];
	LONG minw,minh,maxw,maxh,innerw,innerh,rpt,zl,zt,zw,zh;
	BOOL size,drag,depth,close,back,report,nocare,bord,act,rmb,
	     simple,smart,sizer,sizeb,aut,gimme,zoom;
};

struct New_Wind {
	LONG flags;
	LONG left,top,width,height;
	char title[256];
	LONG minw,minh,maxw,maxh,innerw,innerh,rpt,zl,zt,zw,zh;
	BOOL size,drag,depth,close,back,report,nocare,bord,act,rmb,
	     simple,smart,sizer,sizeb,aut,gimme,zoom;	
};

/* menu structures */
struct title_box {
	char title[256];
	BOOL disabled;
	int index;
	struct item_box *items;
	struct title_box *next;
	struct title_box *prev;
};

struct item_box {
	char item[256];
	BOOL disabled;
	BOOL menubar;
	BOOL checked;
	char type;
	int index;
	char hotkey[5];
	char function[256];
	struct sub_box *submenu;
	struct item_box *next;
	struct item_box *prev;
};

struct sub_box {
	char submenu[256];
	BOOL disabled;
	int index;
	BOOL menubar;
	BOOL checked;
	char type;
	char hotkey[5];
	char function[256];
	struct sub_box *next;
	struct sub_box *prev;
};

struct maingad {
	int id;
	char name[240];
	char text[240];
	int l,t,w,h;
    	char under;
	int type;
	BOOL dis,ng;
	void *data;
	struct listing *datalist;
	BOOL cfont;
	struct maingad *next;
	struct maingad *prev;
};

struct listing {
	char entry[240];
	struct listing *next;
	struct listing *prev;
};

